sub _Decode {
	my($home) = $_[0];

	require "$module_dir/mail_decode.pm";

	open H, "/$home/Mailbox" || &_errorprint("Do Not Open New Mail File");
	binmode H;
	my $mailcount = 0;
	while(<H>)
	{
		if($_ =~ /^From ([a-z0-9-_.]+\@\[?[a-z0-9-_]+(?:\.[a-z0-9-_]+){1,4}\]?)/)
		{
			$mailcount++;
		}
		else
		{
			$mail_msg[$count] .= $_;
		}
	}
	close H;

	shift @mail_msg;

	foreach my $line (@mail_msg)
	{
		&_any($line);
		
	}
}

sub _any {
	my $mail = $_[0];

	($header,@body) = split /\r?\n\r?\n/,$mail;

	$body = join "\r\n\r\n",@body;

	&MailHeaderDecode(\$header);

	my ($boundary) = $header =~ /boundary="(\S+)"/;

	my @sub_mail = split /$boundary/,$body;

	$MAIL_S{$boundary} = $body;

	my $i;

	if($boundary)
	{
		foreach $i (0 .. $#sub_mail)
		{
			&_any($sub_mail[$i]);
		}
	}

	if($header =~ /^Content-Type: /im || $header =~ /Message-ID: /im)
	{
		($ct) = $header =~ /^Content-Type: \s*(\S+)/im;
		($ct) =~ s/(\S+);/$1/;

		if($header =~ /^Message-ID: /im)
		{
			($msg_id) = $header =~ /^Message-ID: <(\S+)>\n/im;
		}

		if($header =~ /^Content-Transfer-Encoding: /im)
		{
			($encode) = $header =~ /^Content-Transfer-Encoding: \s*(\S+)/im;
		}

		if($header =~ /^To: /im)
		{
			($to) = $header =~ /^To: (.*(\S+))\n/im;
		}

		if($header =~ /^From: /im)
		{
			($from) = $header =~ /^From: (.*(\S+))\n/im;
		}

		if($header =~ /^Date: /im)
		{
			($date) = $header =~ /^Date: (.*(\S+))\n/im;
		}

		if($from) {$MAIL{$msg_id}->{from} = $from;}

		if($to) {$MAIL{$msg_id}->{to} = $to;}

		if($date)
		{
			my @date = split / /,$date;

			if($#date == 6)
			{
				$MAIL{$msg_id}->{date}->{week_day} = shift @date;
				$MAIL{$msg_id}->{date}->{month_day} = shift @date;
				$MAIL{$msg_id}->{date}->{month} = shift @date;
				$MAIL{$msg_id}->{date}->{year} = shift @date;
				$MAIL{$msg_id}->{date}->{sendtime} = shift @date;
				$MAIL{$msg_id}->{date}->{gmt} = shift @date;
			}
			else
			{
				$MAIL{$msg_id}->{date}->{month_day} = shift @date;
				$MAIL{$msg_id}->{date}->{month} = shift @date;
				$MAIL{$msg_id}->{date}->{year} = shift @date;
				$MAIL{$msg_id}->{date}->{sendtime} = shift @date;
				$MAIL{$msg_id}->{date}->{gmt} = shift @date;
			}	
		}

		if($msg_id) {$MAIL{$msg_id}->{msg_id} = $msg_id;}

		if(!$ct)
		{
			$ct = "text/plain";
		}

		if($encode =~ /^base64/im)
		{
		       Base64Decode(\$MAIL_S{$boundary});
		}
		elsif($encode =~ /^quoted-printable/im)
		{
		       QPDecode(\$MAIL_S{$boundary});
		}

		if($ct !~ /text/)
		{
			($filename) = $header =~ /name="(\S+)"/im;
			$file_s = $filename;
			$file_s =~ s/ //;
	#		$file_s = $msg_id . $file_s;
			open H, ">/home/lucas/files/$file_s";
			binmode H;
			print H $MAIL_S{$boundary};
			close H;
			$MAIL{$msg_id}->{file}->{$filename}="$filename";
		}
		else
		{
			($MAIL{$msg_id}->{$ct}->{body}) = $MAIL_S{$boundary};
			($MAIL{$msg_id}->{head}) = $header;
		}
	}
}

1;

