
sub _mailsend {

	use Socket;
	my ($from,$to,$cc,$bcc,$subject,$message,$code,$file_data) = @_;
	my($tmp,$x,$attach);
	my $server = "wowdb.com";
	map { $tmp .= $_ } localtime;
	my $BOUNDARY = "--=_$tmp".time.'=--';

	my @to_origin;
	my @cc_ref;
	my @bcc_ref;
	my @to = split ';',$to;
	if($cc)
	{
		@cc_ref = split ';',$cc;
		@to = (@to,@cc_ref);
	}

	if($bcc)
	{
		@bcc_ref = split ';',$bcc;
		@to = (@to,@bcc_ref);
	}

	for($i=0;$i<=$#to;$i++)
	{
		($to_origin[$i]) = $to[$i] =~  /([a-z0-9-_.]+\@\[?[a-z0-9-_]+(?:\.[a-z0-9-_]+){1,4}\]?)/;
	}
	
	if($file_data)
	{
		$attach = 1;
		&_base64(\$file_data->{data});
		&_base64(\$message);
	}
		$subject =~ s/((?:[\x80-\xFE].)+)/'=?EUC-KR?B?'.&_base64h($1).'?='/eg;
		$subject =~ s/(.{70})/$1\r\n\t/g;

	my ($from_origin) = $from =~ /([a-z0-9-_.]+\@\[?[a-z0-9-_]+(?:\.[a-z0-9-_]+){1,4}\]?)/;
	my $proto = (getprotobyname('tcp'))[2];
	my $port  = (getservbyname('smtp', 'tcp'))[2];
	my $smtpaddr = ($server =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/) ? pack ('C4',$1,$2,$3,$4) : (gethostbyname $server)[4];
	
	socket(S, AF_INET, SOCK_STREAM, $proto) or return ('socket error');
	connect(S, pack('Sna4x8', AF_INET, $port, $smtpaddr)) || return('socket connect error');
	my ($oldfh) = select(S);
	$| = 1;
	select($oldfh);

	$x = <S>; if ($x =~ /^[45]/) { close S; return ('socket connect error'); }

	print S "HELO host\r\n";
	$x = <S>; if ($x =~ /^[45]/) { close S; return('host no response'); }

	print S "MAIL FROM: $from_origin\r\n";
	$x = <S>; if ($x =~ /^[45]/) { close S; return ('sender Email address error'); }
	
	foreach $m (@to_origin)
	{
		print S "RCPT TO: $m\r\n";
		$x = <S>;
	}

	print S "DATA\r\n";
	$x = <S>; if($x =~ /^[45]/) { close S; return('error1'); }

	if($attach)
	{
		print S "Mime-Version: 1.0\r\n";
		print S qq|Content-type: MULTIPART/MIXED; BOUNDARY="$BOUNDARY"\r\n|;
	}
	else
	{
		print S "Mime-Version: 1.0\r\n";
		if($code eq 'html')
		{
			print S "Content-Type: text/html; charset=EUC-KR\r\n";
		}
		else
		{
			print S "Content-Type: text/plain; charset=EUC-KR\r\n";
		}
	}
	
	print S "From: $from\r\n";
	print S "To: $to[0]\r\n";
	if($cc)
	{
		print S "Cc: $cc\r\n";
	}

	print S "Subject: $subject\r\n";
	print S "X-Mailer: Mailer maked by Lucas in Lanmart Co., Ltd\r\n";
	print S "\r\n";

	if($file_data)
	{
		print S "--$BOUNDARY\r\n";
		
		if($code eq 'html')
		{
			print S "Content-Type: text/html; charset=EUC-KR\r\n";
			print S "Content-Transfer-Encoding: Base64\r\n\r\n";
		}
		else
		{
			print S "Content-Type: text/plain; charset=EUC-KR\r\n";
			print S "Content-Transfer-Encoding: base64\r\n\r\n";
		}
		print S $message,"\r\n";
	
		print S<<END;
--$BOUNDARY
Content-Type: application/octet-stream; name="$file_data->{name}"
Content-Transfer-Encoding: BASE64

$file_data->{data}
END

		print S "--$BOUNDARY--\r\n";
	}
	else
	{
		print S $message,"\r\n";
	}
	print S "\r\n.\r\n";
	$x = <S>;if($x =~ /^[45]/) { close S; return('error'); }	
	print S "quit\r\n";
	close S;
	return 1;
}

sub _base64 {
	my ($res, $tenp, $pad, $p_length);
	my $data = shift;

	    while ($$data =~ /(.{1,45})/gs) {
			$tmp = $1;
			$tmp = substr(pack('u', $tmp), 1);
			$tmp =~ tr| -_`|A-Za-z0-9+/A|;
			$res .= $tmp;
	    }

	    $pad = (3 - length($$data) % 3) % 3;
		$p_length = length($pad);
		$res =~ s/.{$p_length}$/'=' x $pad/e if $pad;

#		my $pad_n = $pad - $pad *2;
#	    if ($pad) {
#			substr($res, $pad_n, $pad, '=' x $pad);
#		}

		$$data = $res;

}

sub _base64h {
		my ($res, $tenp, $pad, $p_length);
		my $DATA = shift;

	    while ($DATA =~ /(.{1,45})/gs) {
			$tmp = $1;
			$tmp = substr(pack('u', $tmp), 1);
			$tmp =~ tr| -_`|A-Za-z0-9+/A|;
			chomp $tmp;
			$res .= $tmp;
	    }

	    $pad = (3 - length($DATA) % 3) % 3;
		$p_length = length($pad);
		$res =~ s/.{$p_length}$/'=' x $pad/e if $pad;

#		my $pad_n = $pad - $pad *2;
#	    if ($pad) {
#			substr($res, $pad_n, $pad, '=' x $pad);
#		}

		$res;
}

1;
